<script lang="ts">
  import type { KanbanTask } from '../../models/Kanban.js';
  import TaskQuickAssign from './Task/TaskQuickAssign.svelte';
  import type { TeamUser } from '@models/Team';
  import UserBadge from '@components/UserBadge.svelte';
  import Markdown from '@components/Markdown/Markdown.svelte';

  export let teammates: TeamUser[];
  export let task: KanbanTask;
  export let assignTask: ((task_id?: string | undefined) => void) | null = null;
  export let showModal: ((task_id?: string | undefined) => void) | null = null;

  let mouseDown = false;
  let dragging = false;

  let posXInitial = 0;
  let posYInitial = 0;

  let posX = 0;
  let posY = 0;

  let commentCount: number = 0;

  $: assignee = teammates.find((member) => member.id === task.assignee_id);
  $: commentCount = task.comments?.length || 0;

  function onMouseUp(event: MouseEvent) {
    if (!dragging) {
      document.removeEventListener('mousemove', onMouseMove);
      document.removeEventListener('mouseup', onMouseUp);
      if (showModal) showModal(task.id);
      return;
    }
    mouseDown = false;
    dragging = false;
    document.body.style.userSelect = 'auto';
    posX = 0;
    posY = 0;
    document.removeEventListener('mousemove', onMouseMove);
    document.removeEventListener('mouseup', onMouseUp);
    let elem = document
      .elementsFromPoint(event.clientX, event.clientY)
      .find((element) => element.classList.contains('task-column'));
    if (elem) {
      let data = new DataTransfer();
      data.setData('text/plain', task.id);
      elem.dispatchEvent(
        new DragEvent('drop', {
          dataTransfer: data,
        }),
      );
    }
  }

  function onMouseMove(event: MouseEvent) {
    if (!mouseDown) {
      return;
    }
    posX = event.clientX - posXInitial - 250;
    posY = event.clientY - posYInitial - 50;
    if (!dragging) {
      dragging = true;
      document.body.style.userSelect = 'none';
    }
  }
</script>

<div
  class="card hover-outline m-3 overflow-hidden mw-100"
  on:mousedown={() => {
    mouseDown = true;
    document.addEventListener('mousemove', onMouseMove);
    document.addEventListener('mouseup', onMouseUp);
  }}
  style={dragging
    ? `z-index: 100; position: absolute; left: ${posX}px; top: ${posY}px; width: 500px;`
    : 'cursor: pointer;'}
>
  <div class="card-header bg-dark">
    <div class="d-flex flex-row align-middle align-items-center">
      <div class="flex-grow-1 font-weight-bold fs-5 align-middle">{task.title}</div>
      <div class="align-middle text-muted">{`${commentCount} comment${commentCount !== 1 ? 's' : ''}`}</div>
    </div>
  </div>
  <div class="card-body mw-100 text-wrap text-break text-truncate" style="max-height: 150px;">
    <Markdown source={task.description} />
    {#if task.ctf_challenge?.challenge?.description}
      <hr style="border-color: white" />
      <Markdown source={task.ctf_challenge?.challenge?.description} />
    {/if}
  </div>
  <div class="card-footer d-flex flex-row justify-content-between">
    <div class="d-flex flex-column">
      {#if assignee}
        <UserBadge userId={assignee.id} firstName={assignee.first_name} lastName={assignee.last_name} small />
      {/if}
    </div>
    <TaskQuickAssign class="d-flex flex-row ms-auto" {task} {assignTask} small />
  </div>
</div>

<style>
  /* Move text inside cards closer together */
  .card :global(p) {
    margin-bottom: 0;
  }

  /* Add a hover effect to cards in a column */
  .card.hover-outline {
    transition: 0.1s ease-out outline-color;
    outline-color: #5866ff00;
    outline-style: solid;
    outline-width: 2px;
  }

  .card.hover-outline:hover {
    outline-color: #5866ffbd;
  }
</style>
